//----------------------------------------------------------------------------
// ObjectWindows
// Copyright (c) 1991, 1995 by Borland International, All Rights Reserved
//----------------------------------------------------------------------------
#include <owl/pch.h>
#include <owl/applicat.h>
#include <owl/framewin.h>
#include <owl/editfile.h>
#include "statusd.h"
#include "statusd.rh"

#define CM_STATUSDLG 234

class TFileApp : public TApplication {
  public:
    TFileApp() : TApplication("File Window") {}

  protected:
    void   InitMainWindow();
		void   CmShowStatus();

  	DECLARE_RESPONSE_TABLE(TFileApp);
};

DEFINE_RESPONSE_TABLE1(TFileApp, TApplication)
  EV_COMMAND(CM_STATUSDLG, CmShowStatus),
END_RESPONSE_TABLE;

//
// Construct the TFileApp's MainWindow's client of type TEditFile
//
void
TFileApp::InitMainWindow()
{
  MainWindow = new TFrameWindow(0, Name, new TEditFile);
  MainWindow->AssignMenu(IDM_EDITFILE);
  MainWindow->Attr.AccelTable = IDA_EDITFILE;
  MainWindow->SetIcon(this, 201);
}

void
TFileApp::CmShowStatus()
{
	TAPointer<char> Buffer = new char[MAX_PATH];
	TStatusDlg dlg(GetMainWindow(),IDD_STATUS,10000);
  dlg.Create();
  for(int i = 0; i < 10000; i++){
	  Sleep(1000);
		PumpWaitingMessages();
		/* set status text                                                  */
		wsprintf(Buffer, "Current number: %d", i);
		dlg.Step(Buffer);
		if(dlg.Canceled()){
			if(dlg.MessageBox("Abort process?", 0, MB_YESNO|MB_ICONQUESTION) == IDYES){
				break;
			}
		}
  }
}


int
OwlMain(int /*argc*/, char* /*argv*/ [])
{
  return TFileApp().Run();
}
