////////////////////////////////////////////////////////////////////////////////
//    ObjectWindows Library
//    Copyright 1998 by Bidus Yura.
//
//    OVERVIEW
//    ========
//    Class definition for TStatusDlg (TDialog).
////////////////////////////////////////////////////////////////////////////////
//@doc TStatusDlg GUI
#if !defined(__statusd_h)              // Sentry, use file only if it's not already included.
#define __statusd_h

#if	!defined(OWL_PROPERTY_H)
#include <owl/property.h>
#endif

//@class TStatusDlg
//@base public | TDialog
class /*_OWLCLASS*/ TStatusDlg : public TDialog {
	public:
		class TTimeChecker{
			enum enumTimes {
				eWaitTime,
				eLessMinute,
			  eAboutMinute,
			  eLessMinutes,
			  eLesshour,
		  	eAboutHour,
			  eLessHours,
			};
			public:
				TTimeChecker(TModule& module);

			  void Reset();
			  bool Check(char* buf, uint32 count);

  		protected:
				TModule& 	Module;
				uint32 		TickCount;
			  uint32  	StartTime;
			  uint32 		LastValue;
		  	uint   	  Counter;
			  uint 	 		eMessage;
		};

	//@access Public Members
	public:
		//@cmember Constructor
    TStatusDlg(TWindow* parent, TResId resId, int lenght = 100,
                const char* titles = 0, TModule* module=0);
		//@cmember Destructor
		virtual ~TStatusDlg ();
		//@cmember Step(
		void Step(_TCHAR* text);
		//@cmember SetMessage(
		void SetMessage(_TCHAR* text);
    TProperty<uint32> 						Length;
    TProperty<uint32> 						Canceled;
    TTimeChecker& Checker()	{ return PChecker;}

		//@cmember Reset
		void Reset();

	// Public Members
	public:
		virtual void SetupWindow ();

	//@access Private members
	private:
		TAPointer<char> Buffer;
    uint32					CurPos;
    TTimeChecker 		PChecker;

	//@access Protected Responce Functions Members
	protected:
		void	EvClose();
		void	CmClose();

	DECLARE_RESPONSE_TABLE(TStatusDlg);
};


#endif    // __statusd_h sentry.

