//------------------------------------------------------------------------------
//  ObjectWindows Library
//  Copyright  1998 by Yura Bidus. All Rights Reserved.
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TTipDialog (TDialog).
//
//------------------------------------------------------------------------------
//@doc TTipDialog GUI
#if !defined(OWL_TIPDIALG_H) // Sentry, use file only if it's not already included.
#define OWL_TIPDIALG_H

#include <owl/filename.h>


__OWL_BEGIN_NAMESPACE

// Generic definitions/compiler options (eg. alignment) preceeding the
// definition of classes
#include <owl/preclass.h>

//@class Show Tips of the day
//@base public | TDialog
class /*_OWLCLASS*/ TTipDialog : public TDialog {
	//@access Public Members
	public:
		TTipDialog(TWindow *parent, TResId resId, LPCTSTR regkey, TModule* module = 0);

		//@cmember Destructor
		virtual ~TTipDialog();
		//@cmember ShowOnStartup()
		bool ShowOnStartup();

	//@access Protected Data
	protected:
		//@cmember show on startup
		bool		 	ShowDlg;
		//@cmember TipError
		bool		 	TipError;
		//@cmember tip string
		string		CurrentTip;
		//@cmember RegKey
		string 		RegKey;
		//@cmember TipFile
		ifstream 	TipFile;
		//@cmember tip file name
		TFileName FileName;
		//@cmember tip file name
		TBitmap* 	BulbBitmap;

	//@access Public Virtual Members
	public:
		//@cmember SetupWindow
		virtual void SetupWindow ();
		//@cmember CleanupWindow
		virtual void CleanupWindow ();

	//@access Protected Members
	protected:
		//@cmember GetNextTipString
		virtual void GetNextTipString();
		//@cmember OpenTipFile
    virtual void OpenTipFile(long pos);
		//@cmember CloseTipFile
    virtual long CloseTipFile();
		//@cmember Get User data from registry or from file, can be overriden
    // to get data from else place
		virtual long ReadSettings();
		//@cmember Write User data to registry or to file, can be overriden
    // to get data from else place
		virtual void WriteSettings(long pos);
		//@cmember Get Tip FileName user overriden
		virtual string GetTipName();
		//@cmember Get Tip FileName user overriden
		virtual TBitmap* GetBitmap();

	protected:
		//@cmember EvPaint
		void EvPaint ();
		//@cmember CmNextTip Handler
		void CmNextTip();
		//@cmember EvHScroll Handler
		HBRUSH EvCtlColor (HDC hDC, HWND hWndChild, uint ctlType);

	DECLARE_RESPONSE_TABLE(TTipDialog);
  DECLARE_STREAMABLE(/*_OWLCLASS*/, NS_OWL::TTipDialog, 1);
};

// Generic definitions/compiler options (eg. alignment) following the
// definition of classes
#include <owl/posclass.h>

__OWL_END_NAMESPACE

#endif     // OWL_TIPDIALG_H sentry.
